%define pkgname bricxcc
%define svnrev 623

%define version svn_rev%{svnrev}
%define release 1%{?dist}
%define _cachedir /var/cache
%define _logdir /var/log
%define _nxttoolsharedir /usr/share/nxttools
%define _nxtccsharedir /usr/share/nxtcc
%define _localedir /usr/share/locale
%define _udevdir /etc/udev/rules.d
%define udev_lego 70-lego.rules
%define fantommake fantom.mak
%define nbcmake nbcunix.mak
%define tools_32bit toolsunix.mak
%define tools_64bit toolsunix64.mak



Summary: BricxCC Suite
Name: %{pkgname}
Version: %{version}
Release: %{release}
#Source0: %{pkgname}-svn-rev%{svnrev}.tgz
Source1: %udev_lego
Patch0: %{pkgname}-%{fantommake}.patch
#Patch1: %{pkgname}-%{nbcmake}.patch
Patch2: %{pkgname}-%{tools_64bit}.patch
License: MPL
Group: Development/Languages
BuildArch: x86_64
BuildRoot: %{_tmppath}/%{pkgname}-buildroot
BuildRequires: fpc, lazarus, fpc-src
BuildRequires: pascalscript
BuildRequires: svn
BuildRequires: libusb-devel, gdk-pixbuf2-devel
BuildRequires: dos2unix
Requires: libusb
Requires: pascalscript
#Requires: libusb, gdk-pixbuf2

# This should be automated to select 32-bit or 64-bit packages
#%define toolsmakefile %{tools_32bit}
%define toolsmakefile %{tools_64bit}

Prefix: %{_prefix}
URL: http://bricxcc.sourceforge.net/

%description
Bricx Command Center (BricxCC) is a Windows (95, 98, ME, NT, W2K, XP, Vista) program commonly known as an integrated development environment (IDE) for programming the RCX (all versions), Scout, Cybermaster, and Spybot programmable bricks using Dave Baum's Not Quite C (NQC) language. And it supports programming the Scout, RCX2, and Spybot using The LEGO Company's MindScript(tm) and LASM(tm) languages via the Mindstorms 2.5 SDK. It supports programming RCX bricks in C, C++, Pascal, Forth, and Java using the brickOS, pbForth, and leJOS alternate firmwares. BricxCC now also supports programming the new LEGO Mindstorms NXT brick using Not eXactly C (NXC), Next Byte Codes (NBC), and a simple on-brick programming language called NPG. 

Note: The Linux Packages only include tools that are specific to the Linux Platforms

%package lib
Summary: Bricx Command Center Support Libraries
Group: System Environment/Libraries
Requires: libusb

%description lib
Bricx Command Center Support Library provides NXT Fantom driver emulation on the Linux platform.


%package clitools
Summary: Bricx Command Center CLI Tools
Group: Development/Languages
Requires: %{pkgname}-lib

%description clitools

Bricx Command Center CLI tools:
* nbc - NXT Byte Code / Not Exactly C Compiler
* nexttool - NXT Command Line Tool
* wavrsocvt - WAV <-> RSO Converter

Next Byte Codes (NBC) is a simple language with an assembly language
syntax that can be used to program LEGO's NXT programmable brick
(from the new LEGO Mindstorms NXT set).

Not Exactly C (NXC) is a high level language, similar to C, built on
top of the NBC compiler. It can also be used to program the NXT brick.
NXC is basically NQC (Not Quite C) for the NXT.

NeXTTool is a command-line program which lets you talk to the new 
LEGO Mindstorms NXT programmable brick. It uses LEGO Mindstorms NXT Driver 
(Fantom) to communicate with the NXT(^). It supports a wide variety of actions 
for such things as downloading the NXT firmware, downloading and uploading 
files to and from the NXT, checking the battery level, playing sound and 
melody files, playing tones, listing all files on the NXT, and reading input 
and output values.

Wav2Rso is a command line utility which can be used to convert .wav files into 
sound files for the NXT brick (.rso files). It can also convert the other 
direction (i.e., .rso -> .wav). It can produce RSO files with a sample rate 
between 2000 and 16000 (the min/max range of supported sample rates in the 
standard NXT firmware). 

^ On the Linux platform, Fantom is implemented as a library on top of libusb.

%package nxtcc
Summary: NXT Command Center
Group: Programming
Requires:  gdk-pixbuf2
Requires: %{pkgname}-lib
Requires: %{pkgname}-clitools

%description nxtcc
NeXT Command Center is the NeXT Tools application plus a functioning code editor with integrated compiler functionality. Kind of like BricxCC-lite. This is an early release with a number of rough edges and defects. Please report any problems you have using the editor and integrated compiler.



# Normal TGZ Package Build
#%prep
#rm -rf %{buildroot}
#%setup -n %{name}
#%patch0 -p1
#%patch1 -p1
#%patch2 -p1

%build
rm -rf %{pkgname} %{buildroot}
# Don't remove the source directory until we've fixed all build issues
#rm -rf %{buildroot}
# Import SVN Repository
svn co https://bricxcc.svn.sourceforge.net/svnroot/bricxcc %{pkgname} 
# Select specific SVN revision
cd %{pkgname}; svn up -r %{svnrev}

## For normal TGZ build, we start building here
## Otherwise, we would need to start the build process earlier to retrieve from SVN
##%build

# Patch Fantom Lib Makefile
patch -p1 %{fantommake} %{PATCH0}

## Patch NXT NBC Makefile
#patch -p1 NXT/%{nbcmake} %{PATCH1}

# Create 64-bit Makefile
cp -f %{tools_32bit} %{tools_64bit}
patch -p1 %{tools_64bit} %{PATCH2}

# Link Makefile for compiling nbc
ln -sf %{nbcmake} NXT/Makefile

# Cleanup DOS text files
(cd doc
for f in Readme Changelog; do
  dos2unix -n $f $f.tmp && \
  touch -r $f $f.tmp && \
  mv $f.tmp $f
done)

# Fantom Library and Test Tools
make -f fantom.mak all
# NXT Byte Code Compiler
make -f unix.mak nbc
# WAV to RSO converter
make -f wavrsocvtlinux.mak all
# CLI NeXT Tool
make -f nexttool.mak nexttool

# Can't build in Rev. 623
# GUI NeXT Tools
#make -f %{toolsmakefile} nxttools
# GUI NeXT Command Center
#make -f %{toolsmakefile} nxtcc
## Bricxcc does not compile in Linux
## GUI BricX Command Center
#make -f %{toolsmakefile} bricxcc


# install
%install
# Add udev rules
mkdir -p %{buildroot}%{_udevdir}
cp %{SOURCE1} %{buildroot}%{_udevdir}/


mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_mandir}/man1/
mkdir -p %{buildroot}%{_docdir}/%{name}-clitools-%{version}/

cd %{pkgname}
# lib files
install -m 755 libfantom.so  %{buildroot}%{_libdir}
install -m 755 libnxtspirit.so %{buildroot}%{_libdir}
install -m 755 spirittest %{buildroot}%{_bindir}

# nbc files
install -m 755 NXT/nbc %{buildroot}%{_bindir}
install -m 644 doc/nbc.1 %{buildroot}%{_mandir}/man1/
#make -f unix.mak install DISTDIR=%{buildroot}

# nexttool files
install -m 755 nexttool %{buildroot}%{_bindir}
install -m 644 doc/nexttool.1 %{buildroot}%{_mandir}/man1/

# wavrsocvt files
install -m 755 wavrsocvt %{buildroot}%{_bindir}

# Readme and Changelog
cp doc/Changelog doc/Readme %{buildroot}%{_docdir}/%{name}-clitools-%{version}/

%post lib
/usr/sbin/groupadd -f lego
echo "Add users to the lego group to access the NXT device using 'usermod –a –G lego <username>'"
/sbin/udevadm control --reload-rules

# We don't remove the group as there may be other tools (esp. nxt-python) that depend on this
#%preun lib
#/usr/sbin/groupdel lego
#/sbin/udevadm control --reload-rules


%clean
rm -rf %{buildroot}

%files lib
%defattr(-,root,root)
%{_libdir}/*
%attr(755,root,root) %{_bindir}/spirittest
%config %{_udevdir}/%{udev_lego}

%files clitools
%defattr(-,root,root)
%{_docdir}/%{name}-clitools-%{version}/*
%{_mandir}/man1/nbc.1*
%{_mandir}/man1/nexttool.1*
%attr(755,root,root) %{_bindir}/nbc
%attr(755,root,root) %{_bindir}/nexttool
%attr(755,root,root) %{_bindir}/wavrsocvt

%files nxtcc
%defattr(-,root,root)


%changelog
* Tue Sep 25 2012 TC Wan <tcwan@cs.usm.my>
- Initial SPEC file for F17
